"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Renderer = void 0;

var _react = _interopRequireDefault(require("react"));

var _elementMap = _interopRequireDefault(require("./elementMap"));

var _interfaces = require("@chart-parts/interfaces");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createElementFor(vdom, key, handlers) {
  var type = vdom.type,
      children = vdom.children,
      attrs = vdom.attrs,
      style = vdom.style,
      _vdom$transforms = vdom.transforms,
      transforms = _vdom$transforms === void 0 ? [] : _vdom$transforms,
      _vdom$channels = vdom.channels,
      channels = _vdom$channels === void 0 ? {} : _vdom$channels,
      _vdom$metadata = vdom.metadata,
      metadata = _vdom$metadata === void 0 ? {
    index: -1
  } : _vdom$metadata;

  var reactSvgType = _elementMap.default.get(type);

  if (!reactSvgType) {
    return null;
  }

  var translateX = 0;
  var translateY = 0;
  var rotate = 0;
  transforms.forEach(function (t) {
    var transformType = t.type,
        value = t.value;

    if (transformType === _interfaces.VSvgTransformType.translate) {
      translateX += value[0];
      translateY += value[1];
    } else if (transformType === _interfaces.VSvgTransformType.rotate) {
      rotate += value;
    }
  });

  var reactAttrs = _objectSpread({}, attrs, {
    key: key,
    style: style,
    x: translateX,
    y: translateY,
    rotate: rotate
  }); // Map the handlers into the vdom


  Object.keys(channels).forEach(function (eventName) {
    var eventId = channels[eventName];
    var reactEventName = eventName;
    var handler = handlers[eventId];

    reactAttrs[reactEventName] = function (event) {
      return handler(_objectSpread({}, metadata, {
        event: event
      }));
    };
  });

  var result = _react.default.createElement(reactSvgType, reactAttrs, (children || []).map(function (c, index) {
    return _typeof(c) !== 'object' ? c : createElementFor(c, "".concat(key, "::").concat(index), handlers);
  }).filter(function (t) {
    return !!t;
  }));

  return result;
}
/**
 * Renders a Virtual DOM out to React-DOM's Virtual DOM
 */


var Renderer =
/*#__PURE__*/
function () {
  function Renderer() {
    _classCallCheck(this, Renderer);
  }

  _createClass(Renderer, [{
    key: "render",
    value: function render(vdom, handlers) {
      return createElementFor(vdom, 'root', handlers);
    }
  }]);

  return Renderer;
}();

exports.Renderer = Renderer;